<?php
/**
 * ipasspay Payment Module
 * contact: tech@ipasspay.com
 * @package paymentMethod
 * @copyright Copyright 2003-2010 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: ipasspay.php 15420 2010-02-04 21:27:05Z drbyte $
 */
class ipasspay {
	var $code, $title, $description, $enabled, $auth_status, $comment;

// class constructor
	function ipasspay() {
		global $order;

		if (IS_ADMIN_FLAG === true) {
			// Payment module title in Admin
			$this->title = MODULE_PAYMENT_IPASSPAY_TEXT_ADMIN_TITLE;
		} else {
			$this->title = MODULE_PAYMENT_IPASSPAY_TEXT_CATALOG_TITLE;
		}

		$this->code = 'ipasspay';
		$this->description = MODULE_PAYMENT_IPASSPAY_TEXT_DESCRIPTION;
		$this->sort_order = MODULE_PAYMENT_IPASSPAY_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_IPASSPAY_STATUS == 'True') ? true : false);

		if ((int) MODULE_PAYMENT_IPASSPAY_ORDER_STATUS_ID > 0) {
			$this->order_status = MODULE_PAYMENT_IPASSPAY_ORDER_STATUS_ID;
		}

		if (is_object($order)) {
			$this->update_status();
		}

	}

	// class methods
	function update_status() {
		global $order, $db;

		if (($this->enabled == true) && ((int) MODULE_PAYMENT_IPASSPAY_ZONE > 0)) {
			$check_flag = false;
			$check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_IPASSPAY_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
			while (!$check->EOF) {
				if ($check->fields['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
					$check_flag = true;
					break;
				}
				$check->MoveNext();
			}

			if ($check_flag == false) {
				$this->enabled = false;
			}
		}

		// disable the module if the order only contains virtual products
		if ($this->enabled == true) {
			if ($order->content_type != 'physical') {
				$this->enabled = false;
			}
		}
	}

	function javascript_validation() {
		$js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
			'    var cc_owner = document.checkout_payment.ipasspay_cc_owner.value;' . "\n" .
			'    var cc_number = document.checkout_payment.ipasspay_cc_number.value;' . "\n" .
			'    var cc_cvv = document.checkout_payment.ipasspay_cc_cvv.value;' . "\n" .
			'    if (cc_owner == "" || cc_owner.length < ' . CC_OWNER_MIN_LENGTH . ') {' . "\n" .
			'      error_message = error_message + "' . MODULE_PAYMENT_IPASSPAY_TEXT_JS_CC_OWNER . '";' . "\n" .
			'      error = 1;' . "\n" .
			'    }' . "\n" .
			'    if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
			'      error_message = error_message + "' . MODULE_PAYMENT_IPASSPAY_TEXT_JS_CC_NUMBER . '";' . "\n" .
			'      error = 1;' . "\n" .
			'    }' . "\n" .
			'         if (cc_cvv == "" || cc_cvv.length < "3") {' . "\n" .
			'           error_message = error_message + "' . MODULE_PAYMENT_IPASSPAY_TEXT_JS_CC_CVV . '";' . "\n" .
			'           error = 1;' . "\n" .
			'         }' . "\n" .
			'  }' . "\n";

		return $js;
	}

	// Display Credit Card Information Submission Fields on the Checkout Payment Page
	function selection() {
		global $order;

		for ($i = 1; $i < 13; $i++) {
			$expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B - (%m)', mktime(0, 0, 0, $i, 1, 2000)));
		}

		$today = getdate();
		for ($i = $today['year']; $i < $today['year'] + 15; $i++) {
			$expires_year[] = array('id' => strftime('%y', mktime(0, 0, 0, 1, 1, $i)), 'text' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)));
		}

		$onFocus = ' onfocus="methodSelect(\'pmt-' . $this->code . '\')"';

		$selection = array('id' => $this->code,
			'module' => $this->title,
			'fields' => array( /*array('title' => MODULE_PAYMENT_IPASSPAY_TEXT_CREDIT_CARD_OWNER,
	                                                 'field' => zen_draw_input_field('ipasspay_cc_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname'], 'id="'.$this->code.'-cc-owner"'. $onFocus . ' autocomplete="off"'),
					*/
				array('title' => MODULE_PAYMENT_IPASSPAY_TEXT_CREDIT_CARD_NUMBER,
					'field' => zen_draw_input_field('ipasspay_cc_number', $ccnum, 'id="' . $this->code . '-cc-number"' . $onFocus . ' autocomplete="off"'),
					'tag' => $this->code . '-cc-number'),
				array('title' => MODULE_PAYMENT_IPASSPAY_TEXT_CREDIT_CARD_EXPIRES,
					'field' => zen_draw_pull_down_menu('ipasspay_cc_expires_month', $expires_month, strftime('%m'), 'id="' . $this->code . '-cc-expires-month"' . $onFocus) . '&nbsp;' . zen_draw_pull_down_menu('ipasspay_cc_expires_year', $expires_year, '', 'id="' . $this->code . '-cc-expires-year"' . $onFocus),
					'tag' => $this->code . '-cc-expires-month'),
				array('title' => MODULE_PAYMENT_IPASSPAY_TEXT_CVV,
					'field' => zen_draw_input_field('ipasspay_cc_cvv', '', 'size="4" maxlength="4"' . ' id="' . $this->code . '-cc-cvv"' . $onFocus . ' autocomplete="off"') . ' ' . '<a href="javascript:popupWindow(\'' . zen_href_link(FILENAME_POPUP_CVV_HELP) . '\')">' . MODULE_PAYMENT_IPASSPAY_TEXT_POPUP_CVV_LINK . '</a>',
					'tag' => $this->code . '-cc-cvv')));

		return $selection;
	}

	private function create_order() {
		global $order, $order_totals, $insert_id, $order_total_modules;
		$order->info['payment_method'] = MODULE_PAYMENT_UDOPAY_TEXT_CATALOG_TITLE;
		$order->info['payment_module_code'] = $this->code;
		$order->info['order_status'] = $this->order_status;
		$order_totals = $order_total_modules->pre_confirmation_check();
		$order_totals = $order_total_modules->process();
		$insert_id = $order->create($order_totals, 2);
		$order->create_add_products($insert_id);
	}

	function pre_confirmation_check() {
		global $db, $messageStack;

		include DIR_WS_CLASSES . 'cc_validation.php';

		$cc_validation = new cc_validation();
		$result = $cc_validation->validate($_POST['ipasspay_cc_number'], $_POST['ipasspay_cc_expires_month'], $_POST['ipasspay_cc_expires_year']);
		$error = '';
		switch ($result) {
		case -1:
			$error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->cc_number, 0, 4));
			break;
		case -2:
		case -3:
		case -4:
			$error = TEXT_CCVAL_ERROR_INVALID_DATE;
			break;
		case false:
			$error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
			break;
		}

		// save record of errors which occur during checkout_payment validation phase but haven't been sent to gateway yet
		if (($result == false) || ($result < 1)) {
			$payment_error_return = 'payment_error=' . $this->code;
			$error_info2 = '&error=' . urlencode($error) . '&ipasspay_cc_owner=' . urlencode($_POST['ipasspay_cc_owner']) . '&ipasspay_cc_expires_month=' . $_POST['ipasspay_cc_expires_month'] . '&ipasspay_cc_expires_year=' . $_POST['ipasspay_cc_expires_year'];
			$messageStack->add_session('checkout_payment', $error . '<!-- [' . $this->code . '] -->', 'error');
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
		}

		// if no error, continue with validated data:
		$this->cc_card_type = $cc_validation->cc_type;
		$this->cc_card_number = $cc_validation->cc_number;
		$this->cc_expiry_month = $cc_validation->cc_expiry_month;
		$this->cc_expiry_year = $cc_validation->cc_expiry_year;

		/*一页支付专用*/
		$this->before_process();
		$this->after_process();
	}

	function confirmation() {
		// $confirmation = array('title' => $this->title . ': ' . $this->cc_card_type,
		//                       'fields' => array(array('title' => MODULE_PAYMENT_IPASSPAY_TEXT_CREDIT_CARD_OWNER,
		//                                               'field' => $_POST['ipasspay_cc_owner']),
		//                                         array('title' => MODULE_PAYMENT_IPASSPAY_TEXT_CREDIT_CARD_NUMBER,
		//                                               'field' => str_repeat('X', (strlen($this->cc_card_number) - 4)) . substr($this->cc_card_number, -4)),
		//                                         array('title' => MODULE_PAYMENT_IPASSPAY_TEXT_CREDIT_CARD_EXPIRES,
		//                                               'field' => strftime('%B, %Y', mktime(0,0,0,$_POST['ipasspay_cc_expires_month'], 1, '20' . $_POST['ipasspay_cc_expires_year'])))));
		//
		// return $confirmation;
		return false;
	}

	function process_button() {
		// These are hidden fields on the checkout confirmation page
		$process_button_string = /*zen_draw_hidden_field('cc_owner', $_POST['ipasspay_cc_owner']) .*/
		zen_draw_hidden_field('cc_expires', $this->cc_expiry_month . substr($this->cc_expiry_year, -2)) .
		zen_draw_hidden_field('cc_expires_month', $this->cc_expiry_month) .
		zen_draw_hidden_field('cc_expires_year', substr($this->cc_expiry_year, -2)) .
		zen_draw_hidden_field('cc_type', $this->cc_card_type) .
		zen_draw_hidden_field('cc_number', $this->cc_card_number) .
		zen_draw_hidden_field('cc_cvv', $_POST['ipasspay_cc_cvv']) .
		zen_draw_hidden_field('cc_uuid', $this->create_guid());
		$process_button_string .= zen_draw_hidden_field(zen_session_name(), zen_session_id());
		return $process_button_string;
	}

	/**
	 * Prepare and submit the authorization to the gateway
	 */
	function before_process() {
		//var_dump($_REQUEST);exit;
		$this->create_order();
	}

	/**
	 * the function for creating uuid in PHP
	 */
	function create_guid() {
		$charid = strtoupper(md5(uniqid(mt_rand(), true)));
		$hyphen = chr(45); // "-"
		$uuid = substr($charid, 0, 8) . $hyphen
		. substr($charid, 8, 4) . $hyphen
		. substr($charid, 12, 4) . $hyphen
		. substr($charid, 16, 4) . $hyphen
		. substr($charid, 20, 12);
		return $uuid;
	}

	function after_process() {
		//var_dump($_REQUEST);exit;
		//zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
		//exit;

		global $insert_id, $db, $order, $messageStack;

		/*
			执行到这里，订单已经生成，这个时候，将订单和支付数据提交到网关
		*/
		$amount = $order->info['total'] * $order->info['currency_value'];
		$amount = number_format($amount, 2, '.', '');

		//encrypted the sensitive data
		$hash_info = hash("sha256", MODULE_PAYMENT_IPASSPAY_MERCHANT_ID . MODULE_PAYMENT_IPASSPAY_SITE_ID .
			$insert_id . $amount . $order->info['currency'] . MODULE_PAYMENT_IPASSPAY_API_KEY);

		$gateway_url = MODULE_PAYMENT_IPASSPAY_GATEWAY;

		$curlPost = "order_amount=" . $amount;
		$curlPost .= "&order_currency=" . $order->info['currency'];
		$curlPost .= "&mid=" . MODULE_PAYMENT_IPASSPAY_MERCHANT_ID; //商户ID
		$curlPost .= "&site_id=" . MODULE_PAYMENT_IPASSPAY_SITE_ID; //网站ID
		$curlPost .= "&oid=" . $insert_id; //订单ID
		$curlPost .= "&hash_info=" . $hash_info;

		$curlPost .= "&card_no=" . $_POST['cc_number']; //信用卡卡号
		$curlPost .= "&card_ex_year=" . $_POST['cc_expires_year']; //信用卡过期年
		$curlPost .= "&card_ex_month=" . $_POST['cc_expires_month']; //信用卡过期月
		$curlPost .= "&card_cvv=" . $_POST['cc_cvv']; //信用卡CVV

		$curlPost .= '&bill_firstname=' . $order->billing['firstname'];
		$curlPost .= '&bill_lastname=' . $order->billing['lastname'];
		$curlPost .= '&bill_street=' . $order->billing['street_address'];
		$curlPost .= '&bill_city=' . $order->billing['city'];
		$curlPost .= '&bill_state=' . zen_get_zone_code($order->customer['country']['id'], $order->customer['zone_id'], $order->customer['state']);
		$curlPost .= '&bill_country=' . $order->billing['country']['iso_code_2'];
		$curlPost .= '&bill_zip=' . $order->billing['postcode'];
		$curlPost .= '&bill_phone=' . $order->customer['telephone'];
		$curlPost .= '&bill_email=' . $order->customer['email_address'];

		$curlPost .= '&syn_url=' . $_SERVER['HTTP_HOST'];
		$curlPost .= '&asyn_url=' . $_SERVER['HTTP_HOST'];

		$curlPost .= '&source_ip=' . zen_get_ip_address(); //来源IP地址
		$curlPost .= '&source_url=' . $_SERVER["HTTP_REFERER"]; //来源URL地址
		$curlPost .= '&gateway_version=1.0'; //网关版本号
		$curlPost .= '&uuid=' . $_POST['cc_uuid']; //uuid

		/*If it's a rebilling transaction*/
		/*
			$curlPost .= '&rebill_flag=1';
			$curlPost .= '&rebill_cycle=' . $params['rebill_cycle'];
			$curlPost .= '&rebill_amount=' . $params['rebill_amount'];
			$curlPost .= '&rebill_count=' . $params['rebill_count'];
			$curlPost .= '&rebill_firstdate=' . $params['rebill_firstdate'];
		*/

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $gateway_url);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $curlPost);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		$response = curl_exec($ch);
		curl_close($ch);

		//var_dump($curlPost);
		//var_dump($response);
		//exit;

		/*
			至此，提交过程结束，如果返回为空，则返回提交支付界面
		*/
		if ($response == "") {
			//修改订单为失败
			$comment = "Invalid response,please try again.";
			$auth_status = $this->order_status + 2;
			$messageStack->add_session('checkout_payment', $comment, 'caution');
			//修改交易状态和说明
			$this->update_order_info($insert_id, $auth_status, $comment);
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
		}
		//解析返回的JSON
		$back_data = json_decode($response, true);

		if ($back_data['status'] == 1 && $back_data['data']['order_status'] == 2) {
			//返回的说明
			$comment = $back_data['info'];
			//修改订单为成功
			$auth_status = $this->order_status + 1;
			//清空购物车
			unset($_SESSION['order_summary']);
			unset($_SESSION['order_number_created']);
			$_SESSION['cart']->reset(true);
		} else {

			//返回的说明
			$comment = $back_data['info'];
			//交易失败
			$auth_status = $this->order_status + 2;
			$messageStack->add_session('checkout_payment', $comment, 'caution');
		}

		//加入订单历史
		$sql_data_array = array(array('fieldName' => 'orders_id', 'value' => $insert_id, 'type' => 'integer'),
			array('fieldName' => 'orders_status_id', 'value' => $auth_status, 'type' => 'integer'),
			array('fieldName' => 'date_added', 'value' => 'now()', 'type' => 'noquotestring'),
			array('fieldName' => 'customer_notified', 'value' => 1, 'type' => 'integer'),
			array('fieldName' => 'comments', 'value' => $comment, 'type' => 'string'));
		$db->perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

		//修改交易状态和说明
		$sql_data_array = array('orders_status' => $auth_status,
			'orders_date_finished' => 'now()',
		);
		zen_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . (int) $insert_id); //更新订单状

		if ($auth_status == ($this->order_status + 1)) {
			//交易成功

			$notify_html = '
				<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>Payment result</title>
				<style type="text/css">
				*{
				font-family:"Microsoft Yahei","Arial";
				}
				body{
				background:#ECF0F1;
				}
				#system-message{
					height: 200px;
					width: 400px;
					margin-top: -100px;
					margin-left: -200px;
					position: absolute;
					left: 50%;
					top: 50%;
				}

				.success {
				    padding: 0.3em 1em;
				    border-radius: 3px;
				    color: #fff;
					background: #2ECC71;
				}

				</style>

				</head>
				<body>
				<div id="system-message">

				<div class="success">
				<b>Congratulations!</b>Payment success.Your Order ID is:' . $insert_id . '
				</div>

				<p class="detail"></p>
				<p class="jump">
				<a href="">Go Back <<<</a>
				</p>
				</div>
				</body>
				</html>
				';
			echo $notify_html;

		} else {
			//交易失败
			zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
		}
		exit;
	}

	function after_order_create($zf_order_id) {
		//echo $zf_order_id;
		//var_dump($_REQUEST);
		//exit;
		// global $db, $lp_avs, $lp_trans_num;
		//$db->execute("update "  . TABLE_ORDERS . " set lp_avs ='" . $lp_avs . "' where orders_id = '" . $zf_order_id ."'");
		//$db->execute("update "  . TABLE_ORDERS . " set lp_trans_num ='" . $lp_trans_num . "' where orders_id = '" . $zf_order_id ."'");
		// $db->execute("update "  . TABLE_LINKPOINT_API . " set order_id ='" . $zf_order_id . "' where lp_trans_num = '" . $lp_trans_num ."'");
	}

	function get_error() {
		return false;
	}

	function check() {
		global $db;
		if (!isset($this->_check)) {
			$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_IPASSPAY_STATUS'");
			$this->_check = $check_query->RecordCount();
		}
		return $this->_check;
	}

	function install() {
		global $db, $messageStack;
		if (defined('MODULE_PAYMENT_IPASSPAY_STATUS')) {
			$messageStack->add_session('IPASSPAY module already installed.', 'error');
			zen_redirect(zen_href_link(FILENAME_MODULES, 'set=payment&module=ipasspay', 'NONSSL'));
			return 'failed';
		}

		//查看订单状态里有没有Success[ipasspay]的状态
		$check_query = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS .
			" where orders_status_name = 'Pending[ipasspay]' limit 1");

		//如果记录条数小于1，那么就安装的时候就要加上这个状态
		if ($check_query->RecordCount() < 1) {
			$status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);

			$status_id = $status_query->fields['status_id'] + 1;
			$languages = zen_get_languages();

			$pending_status = $status_id; //pending
			$success_status = $status_id + 1; //成功
			$failed_status = $status_id + 2; //失败

			foreach ($languages as $lang) //为所有语言版本设置一样的订单状态
			{
				$db->Execute("insert into " . TABLE_ORDERS_STATUS . "
				(orders_status_id, language_id, orders_status_name) values
				('" . $pending_status . "', '" . $lang['id'] . "', 'Pending[ipasspay]')");

				$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (
				orders_status_id, language_id, orders_status_name) values
				('" . $success_status . "', '" . $lang['id'] . "', 'Success[ipasspay]')");

				$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (
				orders_status_id, language_id, orders_status_name) values
				('" . $failed_status . "', '" . $lang['id'] . "', 'Failed[ipasspay]')");
			}

		}

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable IPASSPAY credit card payment Module', 'MODULE_PAYMENT_IPASSPAY_STATUS', 'True', 'Do you want to accept IPASSPAY payments?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");

		//商户ID
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
	  configuration_key,
	  configuration_value,
	  configuration_description,
	  configuration_group_id,
	  sort_order,
	  date_added) values (
	  		  'Merchant id',
	  		  'MODULE_PAYMENT_IPASSPAY_MERCHANT_ID',
	  		  '',
	  		  'Merchant id of IPASSPAY account',
	  		  '6',
	  		  '0',
	  		  now())");

		//网站ID
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
		  configuration_key,
		  configuration_value,
		  configuration_description,
		  configuration_group_id,
		  sort_order,
		  date_added) values (
		  			  'Site ID',
		  			  'MODULE_PAYMENT_IPASSPAY_SITE_ID',
		  			  '',
		  			  'Site ID of IPASSPAY account',
		  			  '6',
		  			  '0',
		  			  now())");

		//API_KEY
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
			  configuration_key,
			  configuration_value,
			  configuration_description,
			  configuration_group_id,
			  sort_order,
			  date_added) values (
			  				  'API key',
			  				  'MODULE_PAYMENT_IPASSPAY_API_KEY',
			  				  '',
			  				  'API key of IPASSPAY account',
			  				  '6',
			  				  '0',
			  				  now())");
		//GATEWAY
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
			  configuration_key,
			  configuration_value,
			  configuration_description,
			  configuration_group_id,
			  sort_order,
			  date_added) values (
			  				  'GATEWAY URL',
			  				  'MODULE_PAYMENT_IPASSPAY_GATEWAY',
			  				  '',
			  				  'default:https://www.ipasspay.biz/index.php/Gateway/securepay',
			  				  '6',
			  				  '0',
			  				  now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_IPASSPAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_IPASSPAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");

		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_IPASSPAY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
	}

	function remove() {
		global $db;
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		//删除ipasspay的成功和失败状态
		$db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Pending[ipasspay]' ");
		$db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Success[ipasspay]' ");
		$db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Failed[ipasspay]' ");
	}

	function keys() {
		return array('MODULE_PAYMENT_IPASSPAY_STATUS',
			'MODULE_PAYMENT_IPASSPAY_MERCHANT_ID',
			'MODULE_PAYMENT_IPASSPAY_SITE_ID',
			'MODULE_PAYMENT_IPASSPAY_API_KEY',
			'MODULE_PAYMENT_IPASSPAY_GATEWAY',
			'MODULE_PAYMENT_IPASSPAY_ZONE',
			'MODULE_PAYMENT_IPASSPAY_ORDER_STATUS_ID',
			'MODULE_PAYMENT_IPASSPAY_SORT_ORDER');
	}
}
